﻿'use strict';
//14/02/24

/* exported chars */

// Font Awesome
// https://www.fontawesomecheatsheet.com/
const chars = {
	// Web
	lastFm			: '\uf202',
	spotify			: '\uf1bc',
	link			: '\uf0c1',
	upload			: '\uf0ee',
	download		: '\uf0ed',
	cloud			: '\uf0c2',
	// Standard
	ratingOn 		: '\uf005',
	ratingOff		: '\uf006',
	heartOn			: '\uf004',
	heartOff		: '\uf08A',
	music			: '\uf001',
	headphones 		: '\uf025',
	speaker 		: '\uf028',
	microphone 		: '\uf130',
	noMicrophone 	: '\uf131',
	minus			: '\uf068',
	plus			: '\uf067',
	wand			: '\uf0d0',
	wrench			: '\uf0ad',
	cogs			: '\uf085',
	calendar		: '\uf073',
	calendarPlus	: '\uf271',
	bolt			: '\uf0e7',
	dotCircle		: '\uf192',
	hourglassStart	: '\uf251',
	hourglassHalf	: '\uf252',
	hourglassEnd	: '\uf253',
	hourglass		: '\uf254',
	hourglassAlt	: '\uf250',
	lock			: '\uf023',
	unlock			: '\uf09c',
	unlockAlt		: '\uf13e',
	cut				: '\uf0c4',
	sitemap			: '\uf0e8',
	close			: '\uf00d',
	closeAlt		: '\uf2d4',
	expand			: '\uf065',
	exchange		: '\uf0ec',
	ban 			: '\uf05e',
	recycle			: '\uf1b8',
	puzzle			: '\uf12e',
	moon			: '\uf186',
	lightbulb		: '\uf0eb',
	columns			: '\uf0db',
	table			: '\uf0ce',
	chart			: '\uf201',
	chartV2			: '\uf080',
	// Files
	folderOpenBlack	: '\uf07c',
	folderOpenWhite	: '\uf115',
	folderCloseBlack: '\uf07b',
	folderCloseWhite: '\uf114',
	emptyFileWhite	: '\uf016',
	emptyFilesWhite	: '\uf0c5',
	fileWhite		: '\uf0f6',
	emptyFileBlack	: '\uf15b',
	fileBlack		: '\uf15c',
	save 			: '\uf0c7',
	fileCode		: '\uf1c9',
	fileSound		: '\uf1c7',
	signOut			: '\uf08b',
	signIn			: '\uf090',
	// Utilities
	search			: '\uf002',
	menu			: '\uf0C9',
	console			: '\uf120',
	preferences 	: '\uf013',
	searchPlus 		: '\uf00e',
	searchMinus		: '\uf010',
	tag				: '\uf02b',
	tags 			: '\uf02c',
	duplicates 		: '\uf0c5',
	filter 			: '\uf0b0',
	info 			: '\uf05A',
	question		: '\uf29c',
	tasks 			: '\uf0cb',
	history			: '\uf1da',
	bookmark		: '\uf02e',
	send			: '\uf1d9',
	eraser			: '\uf12d',
	clock			: '\uf017',
	// Playback
	prev			: '\uf049',
	next			: '\uf050',
	play			: '\uf04B',
	pause			: '\uf04C',
	stop			: '\uf04D',
	shuffle			: '\uf074',
	// Carets
	left 			: '\uf053',
	right 			: '\uf054',
	up 				: '\uf077',
	down 			: '\uf078',
	// Arrows
	downLongArrow	: '\uf175',
	upLongArrow		: '\uf176',
	leftLongArrow	: '\uf177',
	rightLongArrow	: '\uf178',
	levelDown 		: '\uf149',
	levelUp 		: '\uf148',
	prevCircle 		: '\uf0e2',
	nextCircle 		: '\uf01e',
	downOutline		: '\uf0d7',
	leftOutline		: '\uf0d9',
	// Sort
	sortAlphaAsc	: '\uf15d',
	sortAlphaDes	: '\uf15e',
	sortBarsAsc		: '\uf160',
	sortBarsDes		: '\uf161',
	sortNumAsc		: '\uf162',
	sortNumDes		: '\uf163',
	// Check
	check			: '\uf00c',
	checkCircle		: '\uf058',
	checkCircleAlt	: '\uf05d',
	checkSquare		: '\ud14a',
	checkSquareAlt	: '\uf046',
	// Others
	sadEmoji		: '(◡︵◡)',
	loveEmoji		: '(\u2764 ᵕ \u2764)',
	loveEmojiV1		: '(\u2764 ᵕ \u2764)',
	loveEmojiV2		: '\u2764(˶˃ᆺ˂˶)',
	loveEmojiV3		: '( ∩´ ᐜ `∩)\u2764',
	loveEmojiV4		: '(ෆ˙ᵕ˙ෆ)\u2764',
	loveEmojiCycle	: function (t = 10000) {
		const now = Date.now();
		if (Date.now() - this.loveEmojiCache.time > t) {
			this.loveEmojiCache.id = Math.randomNum(1, 5, {integer: true});
		}
		this.loveEmojiCache.time = now;
		return this['loveEmojiV' + this.loveEmojiCache.id];
	},
	loveEmojiCache: {time: Infinity, id: 1},
};